VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CursorClock"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Const FORMAT_12 As Integer = 1
Private Const FORMAT_24 As Integer = 0

'Private variables
Private OldCursorHandle As Long
Private HandleCurrentCursor As Long
Private FormatTime As Integer 'FORMAT_12 or FORMAT_24

'user32
'Private Declare Function CreateCursor Lib "user32" (ByVal hInstance As Long, ByVal nXhotspot As Long, ByVal nYhotspot As Long, ByVal nWidth As Long, ByVal nHeight As Long, lpANDbitPlane As Any, lpXORbitPlane As Any) As Long
Private Declare Function CreateIconIndirect Lib "user32" (piconinfo As ICONINFO) As Long
Private Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long
Private Declare Function SetSystemCursor Lib "user32" (ByVal hcur As Long, ByVal id As Long) As Long
Private Declare Function CopyImage Lib "user32" (ByVal handle As Long, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
Private Declare Function CopyCursor Lib "user32" Alias "CopyIcon" (ByVal hcur As Long) As Long
Private Declare Function LoadCursorAsId Lib "user32" Alias "LoadCursorA" (ByVal hInstance As Long, ByVal idCursor As Long) As Long
'Private Declare Function GetCursor Lib "user32" ()
Private Type ICONINFO
    fIcon As Long
    xHotspot As Long
    yHotspot As Long
    hbmMask As Long
    hbmColor As Long
End Type
'gdi32
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function CreateBitmap Lib "gdi32" (ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long, ByVal nBitCount As Long, lpBits As Any) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Const IDC_ARROW = &H7F00
Private Const OCR_NORMAL As Long = &H7F00 'WINRESRC.H
Private Const IMAGE_CURSOR As Long = 2
Private Const LR_DEFAULTCOLOR As Long = 0
Private Const SRCCOPY As Long = &HCC0020

Private hbitmap_cursor_current As Long
Private hbitmap_cursor_picture As Long
Private hbitmap_cursor_mask As Long
Private hbitmap_digit_blank As Long
Private hbitmap_digit(0 To 9) As Long

'This method creates a bitmap for a cursor.
'Note that the resource bits are hard-coded in the source.
'This is to avoid VB resource functions and OLE types.
Private Function CreateCursorBitmap() As Long
    Dim bits(128) As Byte
    bits(1) = &H0
    bits(2) = &H0
    bits(3) = &H0
    bits(4) = &H0
    bits(5) = &H40
    bits(6) = &H0
    bits(7) = &H0
    bits(8) = &H0
    bits(9) = &H60
    bits(10) = &H0
    bits(11) = &H0
    bits(12) = &H0
    bits(13) = &H70
    bits(14) = &H0
    bits(15) = &H0
    bits(16) = &H0
    bits(17) = &H78
    bits(18) = &H0
    bits(19) = &H0
    bits(20) = &H0
    bits(21) = &H7C
    bits(22) = &H0
    bits(23) = &H0
    bits(24) = &H0
    bits(25) = &H7E
    bits(26) = &H0
    bits(27) = &H0
    bits(28) = &H0
    bits(29) = &H7F
    bits(30) = &H0
    bits(31) = &H0
    bits(32) = &H0
    bits(33) = &H7F
    bits(34) = &H80
    bits(35) = &H0
    bits(36) = &H0
    bits(37) = &H7F
    bits(38) = &HC0
    bits(39) = &H0
    bits(40) = &H0
    bits(41) = &H7E
    bits(42) = &H0
    bits(43) = &H0
    bits(44) = &H0
    bits(45) = &H76
    bits(46) = &H0
    bits(47) = &H0
    bits(48) = &H0
    bits(49) = &H66
    bits(50) = &H0
    bits(51) = &H0
    bits(52) = &H0
    bits(53) = &H43
    bits(54) = &H0
    bits(55) = &H0
    bits(56) = &H0
    bits(57) = &H3
    bits(58) = &H0
    bits(59) = &H0
    bits(60) = &H0
    bits(61) = &H1
    bits(62) = &H80
    bits(63) = &H0
    bits(64) = &H0
    bits(65) = &H1
    bits(66) = &H80
    bits(67) = &H0
    bits(68) = &H0
    bits(69) = &H0
    bits(70) = &HC0
    bits(71) = &H0
    bits(72) = &H0
    bits(73) = &H0
    bits(74) = &HC0
    bits(75) = &H0
    bits(76) = &H0
    bits(77) = &H0
    bits(78) = &H0
    bits(79) = &H0
    bits(80) = &H0
    bits(81) = &H0
    bits(82) = &H0
    bits(83) = &H0
    bits(84) = &H0
    bits(85) = &H0
    bits(86) = &H0
    bits(87) = &H0
    bits(88) = &H0
    bits(89) = &H3F
    bits(90) = &HFF
    bits(91) = &HFF
    bits(92) = &HFC
    bits(93) = &H7F
    bits(94) = &HFF
    bits(95) = &HFF
    bits(96) = &HFE
    bits(97) = &H7F
    bits(98) = &HFE
    bits(99) = &H7F
    bits(100) = &HFE
    bits(101) = &H7F
    bits(102) = &HFE
    bits(103) = &H7F
    bits(104) = &HFE
    bits(105) = &H7F
    bits(106) = &HFF
    bits(107) = &HFF
    bits(108) = &HFE
    bits(109) = &H7F
    bits(110) = &HFE
    bits(111) = &H7F
    bits(112) = &HFE
    bits(113) = &H7F
    bits(114) = &HFE
    bits(115) = &H7F
    bits(116) = &HFE
    bits(117) = &H7F
    bits(118) = &HFF
    bits(119) = &HFF
    bits(120) = &HFE
    bits(121) = &H3F
    bits(122) = &HFF
    bits(123) = &HFF
    bits(124) = &HFC
    bits(125) = &H0
    bits(126) = &H0
    bits(127) = &H0
    bits(128) = &H0
    
    CreateCursorBitmap = CreateBitmap(32, 32, 1, 1, bits(1))
End Function
'This method creates a bitmap for a cursor mask.
'Note that the resource bits are hard-coded in the source.
'This is to avoid VB resource functions and OLE types.
Private Function CreateCursorMaskBitmap() As Long
    Dim bits(128) As Byte
    bits(1) = &H3F
    bits(2) = &HFF
    bits(3) = &HFF
    bits(4) = &HFF
    bits(5) = &H1F
    bits(6) = &HFF
    bits(7) = &HFF
    bits(8) = &HFF
    bits(9) = &HF
    bits(10) = &HFF
    bits(11) = &HFF
    bits(12) = &HFF
    bits(13) = &H7
    bits(14) = &HFF
    bits(15) = &HFF
    bits(16) = &HFF
    bits(17) = &H3
    bits(18) = &HFF
    bits(19) = &HFF
    bits(20) = &HFF
    bits(21) = &H1
    bits(22) = &HFF
    bits(23) = &HFF
    bits(24) = &HFF
    bits(25) = &H0
    bits(26) = &HFF
    bits(27) = &HFF
    bits(28) = &HFF
    bits(29) = &H0
    bits(30) = &H7F
    bits(31) = &HFF
    bits(32) = &HFF
    bits(33) = &H0
    bits(34) = &H3F
    bits(35) = &HFF
    bits(36) = &HFF
    bits(37) = &H0
    bits(38) = &H1F
    bits(39) = &HFF
    bits(40) = &HFF
    bits(41) = &H0
    bits(42) = &HF
    bits(43) = &HFF
    bits(44) = &HFF
    bits(45) = &H0
    bits(46) = &HFF
    bits(47) = &HFF
    bits(48) = &HFF
    bits(49) = &H0
    bits(50) = &HFF
    bits(51) = &HFF
    bits(52) = &HFF
    bits(53) = &H18
    bits(54) = &H7F
    bits(55) = &HFF
    bits(56) = &HFF
    bits(57) = &H38
    bits(58) = &H7F
    bits(59) = &HFF
    bits(60) = &HFF
    bits(61) = &H7C
    bits(62) = &H3F
    bits(63) = &HFF
    bits(64) = &HFF
    bits(65) = &HFC
    bits(66) = &H3F
    bits(67) = &HFF
    bits(68) = &HFF
    bits(69) = &HFE
    bits(70) = &H1F
    bits(71) = &HFF
    bits(72) = &HFF
    bits(73) = &HFE
    bits(74) = &H1F
    bits(75) = &HFF
    bits(76) = &HFF
    bits(77) = &HFF
    bits(78) = &H3F
    bits(79) = &HFF
    bits(80) = &HFF
    bits(81) = &HFF
    bits(82) = &HFF
    bits(83) = &HFF
    bits(84) = &HFF
    bits(85) = &HFF
    bits(86) = &HFF
    bits(87) = &HFF
    bits(88) = &HFF
    bits(89) = &HC0
    bits(90) = &H0
    bits(91) = &H0
    bits(92) = &H3
    bits(93) = &H80
    bits(94) = &H0
    bits(95) = &H0
    bits(96) = &H1
    bits(97) = &H80
    bits(98) = &H0
    bits(99) = &H0
    bits(100) = &H1
    bits(101) = &H80
    bits(102) = &H0
    bits(103) = &H0
    bits(104) = &H1
    bits(105) = &H80
    bits(106) = &H0
    bits(107) = &H0
    bits(108) = &H1
    bits(109) = &H80
    bits(110) = &H0
    bits(111) = &H0
    bits(112) = &H1
    bits(113) = &H80
    bits(114) = &H0
    bits(115) = &H0
    bits(116) = &H1
    bits(117) = &H80
    bits(118) = &H0
    bits(119) = &H0
    bits(120) = &H1
    bits(121) = &HC0
    bits(122) = &H0
    bits(123) = &H0
    bits(124) = &H3
    bits(125) = &HFF
    bits(126) = &HFF
    bits(127) = &HFF
    bits(128) = &HFF
    
    CreateCursorMaskBitmap = CreateBitmap(32, 32, 1, 1, bits(1))
End Function
'This method creates a bitmap for a digit. All digits are
'5x7 1-bit bitmaps. These bitmaps will be BitBlt'ed onto the
'curent cursor picture bitmap.
Private Function CreateDigitBitmap(digit As Integer) As Long
    Dim bits(7) As Integer
    
    Select Case digit
        Case 0
            bits(1) = &H88
            bits(2) = &H70
            bits(3) = &H70
            bits(4) = &H70
            bits(5) = &H70
            bits(6) = &H70
            bits(7) = &H88
        Case 1
            bits(1) = &HD8
            bits(2) = &H98
            bits(3) = &HD8
            bits(4) = &HD8
            bits(5) = &HD8
            bits(6) = &HD8
            bits(7) = &H88
        Case 2
            bits(1) = &H88
            bits(2) = &H70
            bits(3) = &HF0
            bits(4) = &HE8
            bits(5) = &HD8
            bits(6) = &HB8
            bits(7) = &H0
        Case 3
            bits(1) = &H88
            bits(2) = &H70
            bits(3) = &HF0
            bits(4) = &HC8
            bits(5) = &HF0
            bits(6) = &H70
            bits(7) = &H88
        Case 4
            bits(1) = &HF0
            bits(2) = &HE0
            bits(3) = &HD0
            bits(4) = &HB0
            bits(5) = &H0
            bits(6) = &HF0
            bits(7) = &HF0
        Case 5
            bits(1) = &H0
            bits(2) = &H78
            bits(3) = &H8
            bits(4) = &HF0
            bits(5) = &HF0
            bits(6) = &H70
            bits(7) = &H88
        Case 6
            bits(1) = &H88
            bits(2) = &H78
            bits(3) = &H78
            bits(4) = &H8
            bits(5) = &H70
            bits(6) = &H70
            bits(7) = &H88
        Case 7
            bits(1) = &H0
            bits(2) = &H70
            bits(3) = &HE8
            bits(4) = &HD8
            bits(5) = &HD8
            bits(6) = &HD8
            bits(7) = &HD8
        Case 8
            bits(1) = &H88
            bits(2) = &H70
            bits(3) = &H70
            bits(4) = &H88
            bits(5) = &H70
            bits(6) = &H70
            bits(7) = &H88
        Case 9
            bits(1) = &H88
            bits(2) = &H70
            bits(3) = &H70
            bits(4) = &H80
            bits(5) = &HF0
            bits(6) = &HF0
            bits(7) = &H88
    End Select
    
    CreateDigitBitmap = CreateBitmap(5, 7, 1, 1, bits(1))
End Function
'This method BitBlts a digit onto a cursor bitmap.
'There are four possible positions for a digit to
'be placed: 0,1,2,3.
'Warning: Makes use of many magic number constants
'to position the digits on the bitmap.
Private Sub SetCursorDigit _
( _
    digit As Integer, _
    hBitmapCursor As Long, _
    position As Integer _
)
    
    Dim x As Integer
    Dim y As Integer
    
    Dim hDC_dest As Long
    Dim hDC_source As Long
    Dim hObject_dest_old As Long
    Dim hObject_source_old As Long
  
    'Calculate position of this digit bitmap. Note the use of
    'magic numbers for positioning the digits on the larger bitmap.
    x = 2 + (7 * position)
    'skip 2 pixels past the colon ":".
    If (position > 1) Then
        x = x + 2
    End If
    y = 23
    
    hDC_dest = CreateCompatibleDC(0)
    hDC_source = CreateCompatibleDC(0)
        hObject_dest_old = SelectObject(hDC_dest, hBitmapCursor)
        hObject_source_old = SelectObject(hDC_source, hbitmap_digit(digit))
            Call BitBlt(hDC_dest, x, y, 5, 7, hDC_source, 0, 0, SRCCOPY)
        hObject_source_old = SelectObject(hDC_source, hObject_source_old)
        hObject_dest_old = SelectObject(hDC_dest, hObject_dest_old)
    Call DeleteDC(hDC_source)
    Call DeleteDC(hDC_dest)
End Sub

Private Sub DrawCurrentCursorTime()
    Dim h As Integer
    Dim m As Integer
'    Dim s As Integer
    Dim h1 As Integer
    Dim h2 As Integer
    Dim m1 As Integer
    Dim m2 As Integer
    
    h = CInt(Hour(Now))
    m = CInt(Minute(Now))
'    s = CInt(Second(Now))
    
    'Special case for 12-hour format
    If FormatTime = FORMAT_12 Then
        If (h > 12) Then h = h - 12
        If (h = 0) Then h = 12
    End If
    
    h1 = h \ 10 '\ = integer division
    h2 = h Mod 10
    m1 = m \ 10 '\ = integer division
    m2 = m Mod 10
    
    'Set the digits in their positions 0,1,2,3, but
    'skip first digit if 12-hour format and that digit is zero.
    'The logic could be reversed to get rid of the "else", but
    'this is easier to read.
    If FormatTime = FORMAT_12 And h1 = 0 Then
        'Nothing
    Else
        SetCursorDigit h1, hbitmap_cursor_current, 0
    End If
    SetCursorDigit h2, hbitmap_cursor_current, 1
    SetCursorDigit m1, hbitmap_cursor_current, 2
    SetCursorDigit m2, hbitmap_cursor_current, 3
End Sub
'This cleans the current cursor canvas. IT takes the clean, blank
'cursor picture And BitBlt 's it to the current cursor picture.
Private Sub CopyCleanCursorPicture()
    Dim hDC_dest As Long
    Dim hDC_source As Long
    Dim hObject_dest_old As Long
    Dim hObject_source_old As Long
    hDC_dest = CreateCompatibleDC(0)
    hDC_source = CreateCompatibleDC(0)
        hObject_dest_old = SelectObject(hDC_dest, hbitmap_cursor_current)
        hObject_source_old = SelectObject(hDC_source, hbitmap_cursor_picture)
            Call BitBlt(hDC_dest, 0, 0, 32, 32, hDC_source, 0, 0, SRCCOPY)
        hObject_source_old = SelectObject(hDC_source, hObject_source_old)
        hObject_dest_old = SelectObject(hDC_dest, hObject_dest_old)
    Call DeleteDC(hDC_source)
    Call DeleteDC(hDC_dest)
End Sub

Public Sub SetSystemCursorToCurrentTime()
    Dim hIcon As Long
  
    Dim icon_info As ICONINFO
    
    'Copy a clean cursor picture over the current cursor.
    CopyCleanCursorPicture
    
    'Draw the current time onto the cursor bitmap.
    DrawCurrentCursorTime
    
    'Use the Bitmaps to create a cursor icon.
    icon_info.fIcon = False
    icon_info.xHotspot = 0
    icon_info.yHotspot = 0
    icon_info.hbmColor = hbitmap_cursor_current
    icon_info.hbmMask = hbitmap_cursor_mask
    hIcon = CreateIconIndirect(icon_info)
'I can't seem to get this line to work, so I use CreateIconIndirect instead.
'    hIcon = CreateCursor(App.hInstance, 0, 0, 32, 32, hbitmap_cursor_current, hbitmap_cursor_mask)
    
    'Use the cursor icon to set the system cursor.
    Call SetSystemCursor(hIcon, OCR_NORMAL)
    
    'The Win32 docs say that SetSystemCursor calls DestroyCursor on the
    'passed cursor after it is used, so the client shouldn't be required
    'to destroy the icon. Under WinNT this seems to work. Under Win95,
    'memory seems to leak if I don't call DestroyIcon() manually.
    Debug.Print DestroyIcon(hIcon)
    
End Sub

Public Sub SetHourFormat24()
    FormatTime = FORMAT_24
End Sub

Public Sub SetHourFormat12()
    FormatTime = FORMAT_12
End Sub
Public Sub CursorStart()
    Dim hCursor As Long
    
    'Save the original system cursor, so
    'I can restore it when this object is destroyed.
    hCursor = LoadCursorAsId(0, OCR_NORMAL)
    OldCursorHandle = CopyCursor(hCursor)
'    OldCursorHandle = CopyImage(hCursor, IMAGE_CURSOR, 32, 32, LR_DEFAULTCOLOR)

    'Initialize the bitmap GDI objects.
    hbitmap_cursor_picture = CreateCursorBitmap
    hbitmap_cursor_current = CreateCursorBitmap
    hbitmap_cursor_mask = CreateCursorMaskBitmap
    hbitmap_digit(0) = CreateDigitBitmap(0)
    hbitmap_digit(1) = CreateDigitBitmap(1)
    hbitmap_digit(2) = CreateDigitBitmap(2)
    hbitmap_digit(3) = CreateDigitBitmap(3)
    hbitmap_digit(4) = CreateDigitBitmap(4)
    hbitmap_digit(5) = CreateDigitBitmap(5)
    hbitmap_digit(6) = CreateDigitBitmap(6)
    hbitmap_digit(7) = CreateDigitBitmap(7)
    hbitmap_digit(8) = CreateDigitBitmap(8)
    hbitmap_digit(9) = CreateDigitBitmap(9)

End Sub
Public Sub CursorFinished()
    'Restore the original system cursor.
    If (OldCursorHandle <> 0) Then
        SetSystemCursor OldCursorHandle, OCR_NORMAL
        OldCursorHandle = 0
    End If
    
    'Delete all the bitmap GDI objects.
    DeleteObject (hbitmap_cursor_picture)
    DeleteObject (hbitmap_cursor_current)
    DeleteObject (hbitmap_cursor_mask)
    DeleteObject (CreateDigitBitmap(0))
    DeleteObject (CreateDigitBitmap(1))
    DeleteObject (CreateDigitBitmap(2))
    DeleteObject (CreateDigitBitmap(3))
    DeleteObject (CreateDigitBitmap(4))
    DeleteObject (CreateDigitBitmap(5))
    DeleteObject (CreateDigitBitmap(6))
    DeleteObject (CreateDigitBitmap(9))
    DeleteObject (CreateDigitBitmap(8))
    DeleteObject (CreateDigitBitmap(9))
End Sub

