VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "NotifyIcon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias "Shell_NotifyIconA" _
   (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Long


Private Const NIM_ADD = &H0
Private Const NIM_MODIFY = &H1
Private Const NIM_DELETE = &H2
Private Const NIF_MESSAGE = &H1
Private Const NIF_ICON = &H2
Private Const NIF_TIP = &H4

Private Const WM_MOUSEMOVE = &H200
'Private Const WM_LBUTTONDBLCLK = &H203
'Private Const WM_LBUTTONDOWN = &H201
'Private Const WM_LBUTTONUP = &H202
'Private Const WM_RBUTTONDBLCLK = &H206
'Private Const WM_RBUTTONDOWN = &H204
'Private Const WM_RBUTTONUP = &H205


Private Type NOTIFYICONDATA
    cbSize As Long
    hwnd As Long
    uId As Long
    uFlags As Long
    ucallbackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type

Private TrayIcon As NOTIFYICONDATA
Private AttachedForm As Form

'Used to compare with results of DecodeMessage()
Public Function WM_LBUTTONDBLCLK() As Long
    WM_LBUTTONDBLCLK = &H203
End Function
'Used to compare with results of DecodeMessage()
Public Function WM_RBUTTONUP() As Long
    WM_RBUTTONUP = &H205
End Function


Public Function Add(NewAttachedForm As Form, ToolTip As String) As Boolean
    Set AttachedForm = NewAttachedForm
    TrayIcon.cbSize = Len(TrayIcon)
    TrayIcon.hwnd = AttachedForm.hwnd
    TrayIcon.uId = AttachedForm.Icon
    TrayIcon.uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
    TrayIcon.ucallbackMessage = WM_MOUSEMOVE
    TrayIcon.hIcon = AttachedForm.Icon
    TrayIcon.szTip = ToolTip & Chr$(0)
    Call Shell_NotifyIcon(NIM_ADD, TrayIcon)
End Function

Public Function Delete() As Boolean
    If (TrayIcon.hwnd <> 0) Then
        Call Shell_NotifyIcon(NIM_DELETE, TrayIcon)
        TrayIcon.hwnd = 0
    End If
End Function
'Shell_NotifyIcon encodes the button clicks in the x parameter
'of the WM_MOUSEMOVE message. To use this method pass it the
'x parameter in the MouseMove event handler of a VB form.
'This will return a WM_* message. Compare it to the value of
'the methods WM_LBUTTONDBLCLK() and WM_RBUTTONUP().
'Others could be defined for other buttons, but
'these were all I needed.
Public Function DecodeMessage(x As Single) As Long
    DecodeMessage = x \ Screen.TwipsPerPixelX
End Function

